// URL des services web :
// Villes: http://api.geonames.org/searchJSON?maxRows=10&featureClass=P&lang=fr&username=techweb&name=XXX
// Wiki page: http://api.geonames.org/findNearbyWikipedia?maxRows=20&lang=fr&username=techweb&lat=XXX&lng=XXX

window.onload = function() {
    document.getElementById("search").onclick = doSearch;
};

function doSearch(e) {
    emptyDiv("selectDestination");
    emptyDiv("wiki");
    
    var text = document.getElementById("city").value;
    var url = "http://api.geonames.org/searchJSON?maxRows=10&featureClass=P&lang=fr&username=techweb&name=" + text;

    var xhr = new XMLHttpRequest();
    xhr.open("GET", url, true);

    xhr.onload = function(e) {
        feedList(this.responseText);
    }

    xhr.onerror = function(e) {
        alert("The request has failed!");
    }

    xhr.send(null);
}

function feedList(json) {
    cities = JSON.parse(json);
    console.log(cities);

    var div = emptyDiv("selectDestination");

    sel = document.createElement("select");
    opt = document.createElement("option");
    opt.innerHTML = "(" + cities.totalResultsCount + " results found)";
    sel.appendChild(opt);
    for (var i = 0; i < cities.geonames.length; i++) {
        opt = document.createElement("option");
        opt.value = cities.geonames[i].lng + "," + cities.geonames[i].lat;
        opt.innerHTML = cities.geonames[i].name + ", " + cities.geonames[i].countryName;
        sel.appendChild(opt);
    }
    div.appendChild(sel);

    div.onchange = function(e) {
        emptyDiv("wiki");
        if (e.target.selectedIndex > 0) {
            lngLat = e.target.options[e.target.selectedIndex].value.split(",");
            doWikipedia(lngLat[0], lngLat[1]);
        }
    };
}

function doWikipedia(lng, lat) {
    var url = "http://api.geonames.org/findNearbyWikipedia?maxRows=20&lang=fr&username=techweb&lat=" + lat + "&" + "lng=" + lng;

    var xhr = new XMLHttpRequest();
    xhr.open("GET", url, true);

    xhr.onload = function(e) {
        feedWiki(this.responseXML);
    }

    xhr.onerror = function(e) {
        alert("The request has failed!");
    }

    xhr.send(null);
}

function feedWiki(data) {
    var div = document.getElementById("wiki");
    ul = document.createElement("ul");
    
    var titles = data.getElementsByTagName("entry");
    for (var i = 0; i < titles.length; i++) {
        title = titles[i].getElementsByTagName("title");
        url = titles[i].getElementsByTagName("wikipediaUrl");
        
        li = document.createElement("li");
        a = document.createElement("a");
        a.setAttribute("target", "_blank");
        a.setAttribute("href", url[0].firstChild.nodeValue)
        a.innerHTML = title[0].firstChild.nodeValue;
        
        li.appendChild(a);        
        ul.appendChild(li);
    }
    div.appendChild(ul);
}

function emptyDiv(id) {
    var div = document.getElementById(id);
    while (div.firstChild)
        div.removeChild(div.firstChild);
    return div;
}